"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Alert = void 0;
var React = __importStar(require("react"));
var react_1 = require("react");
var material_1 = require("@mui/material");
var build_1 = require("react-persistent-state/build");
var color_1 = require("../_core/style/color");
var height = function (dense) { return dense ? 44 : 52; };
var Alert = function (_a) {
    var type = _a.type, dense = _a.dense, children = _a.children, hidden = _a.hidden, icon = _a.icon, action = _a.action, deletable = _a.deletable, persistentDelete = _a.persistentDelete, sx = _a.sx, gutterBottom = _a.gutterBottom, props = __rest(_a, ["type", "dense", "children", "hidden", "icon", "action", "deletable", "persistentDelete", "sx", "gutterBottom"]);
    var _b = (0, build_1.usePersistentState)(true, props.id || 'alert'), isPersistentVisible = _b[0], setPersistentIsVisible = _b[1];
    var _c = (0, react_1.useState)(true), isVisible = _c[0], setIsVisible = _c[1];
    var getIconFromType = function () {
        switch (type) {
            case 'info':
                return 'info';
            case 'error':
                return 'error';
            case 'warning':
                return 'warning';
            case 'success':
                return 'check_circle';
            default:
                return 'info';
        }
    };
    return (React.createElement(material_1.Box, __assign({}, props, { sx: __assign(__assign(__assign(__assign({ 
            // paddingLeft: t.spacing(2),
            // paddingRight: t.spacing(2),
            // [t.breakpoints.up('sm')]: {
            //   paddingLeft: t.spacing(3),
            //   paddingRight: t.spacing(3),
            // },
            transition: function (t) { return t.transitions.create('all'); }, 
            // @ts-ignore
            minHeight: height(props.dense), display: 'flex', alignItems: 'center', overflow: 'hidden', borderRadius: '4px', 
            // @ts-ignore
            paddingLeft: dense ? 1 : 2, paddingRight: dense ? 1 : 2 }, ({
            success: {
                background: 'rgba(50, 255, 150, .08)',
                color: (0, material_1.darken)(color_1.colorSuccess, .1),
            },
            info: {
                background: 'rgba(50, 200, 255, .08)',
                color: (0, material_1.darken)(color_1.colorInfo, .1),
            },
            error: {
                background: 'rgba(255, 0, 0, .08)',
                color: (0, material_1.darken)(color_1.colorError, .1),
            },
            warning: {
                background: 'rgba(255, 128, 0, .08)',
                color: (0, material_1.darken)(color_1.colorWarning, .1),
            },
        })[type]), (hidden || !isVisible || (persistentDelete && !isPersistentVisible)) && {
            minHeight: '0 !important',
            height: '0 !important',
            opacity: '0 !important',
            margin: '0 !important',
        }), gutterBottom && {
            mb: 1
        }), sx) }),
        React.createElement(material_1.Icon, { sx: {
                mr: 1,
                height: height(dense) + "px !important",
                display: 'flex',
                alignItems: 'center',
                alignSelf: 'flex-start',
            } }, icon ? icon : getIconFromType()),
        React.createElement(material_1.Box, { sx: {
                flex: 1,
                py: dense ? 1 : 2,
            } }, children),
        React.createElement(material_1.Box, { sx: {
                textAlign: 'right',
                mt: 1,
                ml: 1 / 2,
                mb: 0,
                mr: -2
            } },
            action,
            deletable &&
                React.createElement(material_1.IconButton, { onClick: function () {
                        setIsVisible(false);
                        if (persistentDelete)
                            setPersistentIsVisible(false);
                    }, size: "large" },
                    React.createElement(material_1.Icon, null, "clear")))));
};
exports.Alert = Alert;
//# sourceMappingURL=Alert.js.map