"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BtnUploader = void 0;
var React = __importStar(require("react"));
var react_1 = require("react");
var material_1 = require("@mui/material");
var Btn_1 = require("../Btn");
var color_1 = require("../_core/style/color");
var common_1 = require("../_utils/common");
var sx = (0, common_1.makeSx)({
    doc_icon: {
        color: function (t) { return t.palette.text.secondary; },
        fontSize: function (t) { return t.typography.subtitle1.fontSize; },
    },
});
var defaultMsg = {
    loading: 'Loading...',
    upload: 'Upload',
    invalidSize: 'File is too big',
};
// TODO(Alex) Fix wierd typing issue (it works for <Btn>)
var BtnUploader = function (_a) {
    var document = _a.document, uploading = _a.uploading, _b = _a.msg, msg = _b === void 0 ? defaultMsg : _b, onUpload = _a.onUpload, onDelete = _a.onDelete, maxUploadFileSize = _a.maxUploadFileSize, other = __rest(_a, ["document", "uploading", "msg", "onUpload", "onDelete", "maxUploadFileSize"]);
    var _c = (0, react_1.useState)(undefined), errorMessage = _c[0], setErrorMessage = _c[1];
    var fileInputEl = (0, react_1.useRef)(null);
    var openFileSelection = function () {
        fileInputEl.current.click();
    };
    var handleChange = function (files) {
        if (!files) {
            return;
        }
        var file = files[0];
        if (maxUploadFileSize && file.size > maxUploadFileSize * 1024 * 1024) {
            setErrorMessage(msg.invalidSize);
            return;
        }
        onUpload(file);
    };
    var clear = function () {
        onDelete();
    };
    var renderBody = function () {
        if (uploading) {
            return (React.createElement(material_1.Chip, { sx: {
                    color: function (t) { return t.palette.text.disabled; },
                    position: 'relative',
                }, label: msg.loading, avatar: React.createElement(material_1.Avatar, { style: { position: 'initial' } },
                    React.createElement(material_1.CircularProgress, { size: 32, sx: {
                            position: 'absolute',
                            top: 0,
                            right: 0,
                            left: 1,
                            bottom: 0,
                        } }),
                    React.createElement(material_1.Icon, { sx: sx.doc_icon }, "insert_drive_file")) }));
        }
        else {
            if (document) {
                return (React.createElement(material_1.Chip, { label: document.name, onDelete: clear, onClick: function () { return window.open(document.permalink, '_blank'); }, avatar: React.createElement(material_1.Avatar, null,
                        React.createElement(material_1.Icon, { sx: sx.doc_icon }, "insert_drive_file")) }));
            }
            else {
                return (React.createElement(Btn_1.Btn, __assign({ color: "primary", onClick: openFileSelection, icon: "file_upload" }, other),
                    msg.upload,
                    React.createElement("input", { style: { display: 'none' }, type: "file", ref: fileInputEl, onChange: function (e) { return handleChange(e.target.files); } })));
            }
        }
    };
    return (React.createElement(material_1.Box, { sx: {
            minHeight: 40,
            display: 'flex',
            alignItems: 'center',
        } },
        renderBody(),
        errorMessage &&
            React.createElement(material_1.Box, { sx: {
                    display: 'flex',
                    alignItems: 'center',
                    ml: 1,
                    color: color_1.colorError,
                    py: 1,
                    px: 2,
                    borderRadius: '2px',
                } },
                React.createElement(material_1.Icon, { sx: { mr: 1 } }, "warning"),
                errorMessage,
                React.createElement(material_1.Icon, { sx: {
                        ml: 1,
                        cursor: 'pointer',
                    }, onClick: function () { return setErrorMessage(''); } }, "clear"))));
};
exports.BtnUploader = BtnUploader;
//# sourceMappingURL=BtnUploader.js.map