"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_1 = require("react");
var material_1 = require("@mui/material");
var GlobalProgressContext_1 = require("./GlobalProgressContext");
var react_hooks_lib_1 = require("@alexandreannic/react-hooks-lib");
var progressbarColor = function (t) {
    return t.palette.primary.main;
};
var INITIAL_PERCENT = 10;
var GlobalProgressBar = function (_a) {
    var styleProgress = _a.styleProgress, sxProgress = _a.sxProgress, props = __rest(_a, ["styleProgress", "sxProgress"]);
    var _b = (0, GlobalProgressContext_1.useGlobalProgressState)(), currentStep = _b.currentStep, steps = _b.steps, started = _b.started;
    var _c = (0, react_1.useState)(0), autoIncrement = _c[0], setAutoIncrement = _c[1];
    (0, react_hooks_lib_1.useInterval)(function () {
        setAutoIncrement(autoIncrement + 1);
    }, 500);
    (0, react_1.useEffect)(function () {
        setAutoIncrement(0);
    }, [steps, currentStep]);
    var stepProgress = (100 - INITIAL_PERCENT) / steps;
    var percent = Math.min(INITIAL_PERCENT + stepProgress * currentStep + Math.min(autoIncrement, stepProgress), 100);
    return (React.createElement(material_1.Box, __assign({ sx: {
            position: 'absolute',
            top: 0,
            left: 0,
            right: 0,
            width: '100%',
            visibility: 'visible',
            opacity: 1,
            transition: 'all 400ms',
            zIndex: 9999,
        } }, props),
        React.createElement(material_1.Box, { sx: __assign(__assign({ background: function (t) { return progressbarColor(t); }, boxShadow: function (t) { return "0 0 10px " + progressbarColor(t) + ", 0 0 5px " + progressbarColor(t); }, height: 2, transition: function (t) { return t.transitions.create('all', { duration: GlobalProgressContext_1.progressbarAnimationDuration }); } }, !started && {
                height: '0px !important',
            }), sxProgress), style: __assign(__assign({}, styleProgress), { width: percent + '%' }) })));
};
exports.default = GlobalProgressBar;
//# sourceMappingURL=GlobalProgressBar.js.map